	component RL02_System is
		port (
			altpll_0_areset_export : in    std_logic                     := 'X';             -- export
			altpll_0_locked_export : out   std_logic;                                        -- export
			clk_clk                : in    std_logic                     := 'X';             -- clk
			clk_65_6_clk           : in    std_logic                     := 'X';             -- clk
			clk_sdram_clk          : out   std_logic;                                        -- clk
			d1_reset_reset_n       : in    std_logic                     := 'X';             -- reset_n
			d2_reset_reset_n       : in    std_logic                     := 'X';             -- reset_n
			dpr_clockbridge_in_clk : in    std_logic                     := 'X';             -- clk
			dpr_s2_address         : in    std_logic_vector(12 downto 0) := (others => 'X'); -- address
			dpr_s2_chipselect      : in    std_logic                     := 'X';             -- chipselect
			dpr_s2_clken           : in    std_logic                     := 'X';             -- clken
			dpr_s2_write           : in    std_logic                     := 'X';             -- write
			dpr_s2_readdata        : out   std_logic_vector(15 downto 0);                    -- readdata
			dpr_s2_writedata       : in    std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			dpr_s2_byteenable      : in    std_logic_vector(1 downto 0)  := (others => 'X'); -- byteenable
			pio_0_in_port          : in    std_logic_vector(15 downto 0) := (others => 'X'); -- in_port
			pio_0_out_port         : out   std_logic_vector(15 downto 0);                    -- out_port
			pio_1_in_port          : in    std_logic_vector(23 downto 0) := (others => 'X'); -- in_port
			pio_1_out_port         : out   std_logic_vector(23 downto 0);                    -- out_port
			spi_master_cs          : out   std_logic;                                        -- cs
			spi_master_sclk        : out   std_logic;                                        -- sclk
			spi_master_mosi        : out   std_logic;                                        -- mosi
			spi_master_miso        : in    std_logic                     := 'X';             -- miso
			uart_0_rxd             : in    std_logic                     := 'X';             -- rxd
			uart_0_txd             : out   std_logic;                                        -- txd
			uart_1_rxd             : in    std_logic                     := 'X';             -- rxd
			uart_1_txd             : out   std_logic;                                        -- txd
			wire_sdram_addr        : out   std_logic_vector(12 downto 0);                    -- addr
			wire_sdram_ba          : out   std_logic_vector(1 downto 0);                     -- ba
			wire_sdram_cas_n       : out   std_logic;                                        -- cas_n
			wire_sdram_cke         : out   std_logic;                                        -- cke
			wire_sdram_cs_n        : out   std_logic;                                        -- cs_n
			wire_sdram_dq          : inout std_logic_vector(15 downto 0) := (others => 'X'); -- dq
			wire_sdram_dqm         : out   std_logic_vector(1 downto 0);                     -- dqm
			wire_sdram_ras_n       : out   std_logic;                                        -- ras_n
			wire_sdram_we_n        : out   std_logic                                         -- we_n
		);
	end component RL02_System;

	u0 : component RL02_System
		port map (
			altpll_0_areset_export => CONNECTED_TO_altpll_0_areset_export, --    altpll_0_areset.export
			altpll_0_locked_export => CONNECTED_TO_altpll_0_locked_export, --    altpll_0_locked.export
			clk_clk                => CONNECTED_TO_clk_clk,                --                clk.clk
			clk_65_6_clk           => CONNECTED_TO_clk_65_6_clk,           --           clk_65_6.clk
			clk_sdram_clk          => CONNECTED_TO_clk_sdram_clk,          --          clk_sdram.clk
			d1_reset_reset_n       => CONNECTED_TO_d1_reset_reset_n,       --           d1_reset.reset_n
			d2_reset_reset_n       => CONNECTED_TO_d2_reset_reset_n,       --           d2_reset.reset_n
			dpr_clockbridge_in_clk => CONNECTED_TO_dpr_clockbridge_in_clk, -- dpr_clockbridge_in.clk
			dpr_s2_address         => CONNECTED_TO_dpr_s2_address,         --             dpr_s2.address
			dpr_s2_chipselect      => CONNECTED_TO_dpr_s2_chipselect,      --                   .chipselect
			dpr_s2_clken           => CONNECTED_TO_dpr_s2_clken,           --                   .clken
			dpr_s2_write           => CONNECTED_TO_dpr_s2_write,           --                   .write
			dpr_s2_readdata        => CONNECTED_TO_dpr_s2_readdata,        --                   .readdata
			dpr_s2_writedata       => CONNECTED_TO_dpr_s2_writedata,       --                   .writedata
			dpr_s2_byteenable      => CONNECTED_TO_dpr_s2_byteenable,      --                   .byteenable
			pio_0_in_port          => CONNECTED_TO_pio_0_in_port,          --              pio_0.in_port
			pio_0_out_port         => CONNECTED_TO_pio_0_out_port,         --                   .out_port
			pio_1_in_port          => CONNECTED_TO_pio_1_in_port,          --              pio_1.in_port
			pio_1_out_port         => CONNECTED_TO_pio_1_out_port,         --                   .out_port
			spi_master_cs          => CONNECTED_TO_spi_master_cs,          --         spi_master.cs
			spi_master_sclk        => CONNECTED_TO_spi_master_sclk,        --                   .sclk
			spi_master_mosi        => CONNECTED_TO_spi_master_mosi,        --                   .mosi
			spi_master_miso        => CONNECTED_TO_spi_master_miso,        --                   .miso
			uart_0_rxd             => CONNECTED_TO_uart_0_rxd,             --             uart_0.rxd
			uart_0_txd             => CONNECTED_TO_uart_0_txd,             --                   .txd
			uart_1_rxd             => CONNECTED_TO_uart_1_rxd,             --             uart_1.rxd
			uart_1_txd             => CONNECTED_TO_uart_1_txd,             --                   .txd
			wire_sdram_addr        => CONNECTED_TO_wire_sdram_addr,        --         wire_sdram.addr
			wire_sdram_ba          => CONNECTED_TO_wire_sdram_ba,          --                   .ba
			wire_sdram_cas_n       => CONNECTED_TO_wire_sdram_cas_n,       --                   .cas_n
			wire_sdram_cke         => CONNECTED_TO_wire_sdram_cke,         --                   .cke
			wire_sdram_cs_n        => CONNECTED_TO_wire_sdram_cs_n,        --                   .cs_n
			wire_sdram_dq          => CONNECTED_TO_wire_sdram_dq,          --                   .dq
			wire_sdram_dqm         => CONNECTED_TO_wire_sdram_dqm,         --                   .dqm
			wire_sdram_ras_n       => CONNECTED_TO_wire_sdram_ras_n,       --                   .ras_n
			wire_sdram_we_n        => CONNECTED_TO_wire_sdram_we_n         --                   .we_n
		);

