#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <system.h>
#include <sys/alt_alarm.h>
#include <io.h>
#include "fatfs.h"
#include "diskio.h"
#include "ff.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_uart_regs.h"
//
// Global
FILE* fp;
unsigned char c;
//
void longdelay(int wait);
void esp8266output(void);
void check_SD_Card(void);
void readwlan(void);
void printloop(void);
//#########################################################################################################
//                                            SD-CARD & FAT32
static FATFS Fatfs;
static alt_alarm alarm;
static unsigned long Systick = 0;
static volatile unsigned short Timer;   // 1000Hz increment timer

static alt_u32 TimerFunction (void *context)
{
   static unsigned short wTimer10ms = 0;

   (void)context;

   Systick++;
   wTimer10ms++;
   Timer++;

   if (wTimer10ms == 10)
   {
      wTimer10ms = 0;
      ffs_DiskIOTimerproc();  // Drive timer procedure of low level disk I/O module
   }

   return(1);
}

static void IoInit(void)
{
   // Init diskio interface
   ffs_DiskIOInit();
   // Init timer system
   alt_alarm_start(&alarm, 1, &TimerFunction, NULL);
}
//###################################################################################################
//


void longdelay( int wait)
{
     while (wait) {
           wait = wait -1;
     }
}
//---------------------------------------------------------------------------------------------------
//
 /*
void esp8266output()
 {
	while ((c = fgetc(fp)) != 10)  {
       printf("%c",c);
    }
}
 */
//
 /*
void esp8266output()
{
	 int timeout, count;
	 unsigned char old;
	 old = '\r';
	 char string[1024]="";
	 count = 0;
	 timeout=0;
	 //
	 IOWR_ALTERA_AVALON_UART_STATUS(UART_1_BASE, 0); // clear all error flags
     while (timeout  <= 300000) {
	   c = (IORD_ALTERA_AVALON_UART_RXDATA(UART_1_BASE));
	   //
	   if(c != old) {
	      string[count] = c;
	      old = c;
	      timeout = 0;
	      count++;
       }else{
          timeout++;
	   }
     }
     printf("%s",string);
 }
*/
//
//---------------------------------------------------------------------------------------------------
// /* Meine Idee
void esp8266output()
 {
  int timeout, count;
  char string[1024]="";
  count = 0;
  timeout=0;
  //
  //IOWR_ALTERA_AVALON_UART_STATUS(UART_1_BASE, 0); // clear all error flags
  //fflash(fp);
  //
  while (timeout  <= 800000)
   {
   if (( IORD_ALTERA_AVALON_UART_STATUS(UART_1_BASE) & 0x0080))
    {
	  c = (IORD_ALTERA_AVALON_UART_RXDATA(UART_1_BASE));
	  string[count] = c;
	  count++;
	  timeout = 0;
    }else{
	  timeout++;
    }
  }
  printf("%s",string);
}
//*/
//
/* Jonny Idee
void esp8266output()
{
  int timeout;
  unsigned int status;
  //unsigned char c;
  timeout = 0;
  while (timeout  <= 800000) // ist 1000 nicht viel zu kurz???
  {
    status = IORD_ALTERA_AVALON_UART_STATUS(UART_1_BASE);
    IOWR_ALTERA_AVALON_UART_STATUS(UART_1_BASE, 0); // clear all error flags
    if (status & ALTERA_AVALON_UART_CONTROL_RRDY_MSK)
    {
      //c = fgetc(fp);
      c = (IORD_ALTERA_AVALON_UART_RXDATA(UART_1_BASE));
      printf("RX=%02x\r\n",c);  // besser in hex ausgeben, damit Du die Steuerzeichen siehst
      timeout = 0;
    }else{
      timeout++;
    }
  }
  printf("timeout\r\n");
}
*/
//
void check_SD_Card(void){
  DSTATUS DStatus;
  FRESULT FResult;
  //
  DStatus = disk_initialize(0);
  if (DStatus != 0){
    printf ("\n\r\x07 No SD card! Insert SD-Card & restart system \n\r");
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_1_BASE, 0x0000);                           //$$
    while(1); }
  //
  FResult = f_mount(0, &Fatfs);
  if (FResult != FR_OK){
    printf ("\n\r\x07 No valid SD card! Restart system \n\r");
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_1_BASE, 0x0000);                           //$$
    while(1); }
}
//
//
void readwlan(void)
{
	char *wlanfile = "ESP8266.CFG";
	FRESULT FResult;
	FIL     hFile;
	char EineZeile[100];
	//
	printf ("\n\r>>  Read from file %s \n\r", wlanfile);
	//
	FResult = f_open(&hFile, wlanfile, FA_READ);
	if (FResult != FR_OK) {
	   printf ("\n\n\r\x07 ERROR opening WLAN config file ESP8266.CFG \n\n\r");
	   while(1);
	}
	while ((f_eof(&hFile) == 0)) {
	  f_gets(EineZeile, sizeof(EineZeile), &hFile);  // read EineZeile
	  if (EineZeile[0] =='#'){
	     printf ("%s", EineZeile);
	  }else if (EineZeile[0] =='*'){
	  	 printf ("%s", EineZeile);
	  	 IOWR_ALTERA_AVALON_PIO_DATA(PIO_1_BASE, 0xC000);               // PIO via NIOS-control
	  	 IOWR_ALTERA_AVALON_PIO_DATA(PIO_0_BASE, 0xFFFF);               // All DE10 LED's ON
	     while ((IORD_ALTERA_AVALON_PIO_DATA(PIO_1_BASE) & 0x4000 ));   // Wait, until Button_2 = pessed
	  	 IOWR_ALTERA_AVALON_PIO_DATA(PIO_0_BASE, 0x0);                  // All DE10 LED's OFF
	  }else{
		 printf ("Send to ESP8266> %s", EineZeile);
		 fprintf(fp, "%s", EineZeile);
		 longdelay(900000);
	  }
	}
	FResult = f_close(&hFile);
}
//
void printloop(void){
	int i;
	//fp = fopen ("/dev/uart_0", "r+");
	printf("\n\r    Print to ESP loop     \n\r");
	while(1){
		for (i = 0; i< 40; i++ ) {
			 fprintf(fp, "Print-Loop to ESP8266 %d Hallo \r\n", i);
			 printf("Print-Loop to ESP8266 %d Hallo \r\n", i);
		}
		longdelay(900000);
		printf("\n\r  Ein Loop done");
	}

}
//
int main()
{
	int wlanmode;
   //----
   //fdterm = open("/dev/uart_1", "O_RDWR | O_NONBLOCK | O_NOCTTY");
   //fp = fdopen(fdterm,"rw+");
   //fp = fopen("/dev/uart_1", "O_RDWR | O_NONBLOCK");
   //fp = fopen ("/dev/uart_1", "r+");
   //fp = fopen ("/dev/uart_1", "r+ | O_NONBLOCK");                           // Open file for reading and writing
   //fp = fopen ("/dev/uart_1", "r+ | O_RDWR | O_NONBLOCK | O_NOCTTY");         // Open file for reading and writing
   //fp = fopen ("/dev/uart_0","r+ | O_RDWR");
   //
   fp = fopen ("/dev/uart_1", "r+ | O_RDWR | O_NONBLOCK | O_NOCTTY");         // Open file for reading and writing
   //
   //
   //fprintf(fp, "\n\r\x1B[2J       UART - WLAN test    \n\r\n\n");
   //while(1);
   printf("\n\r\x1B[2J       UART - WLAN test    \n\r\n\n");
   //-----------------------------------------------------------------------------------------------------------------
   fprintf(fp, "AT+RST\r\n"); longdelay(800000);
   printf("ESP8266 IP-Adress:\n\r ");
   fprintf(fp, "AT+CIFSR\r\n");           // AT+CIFSR : Shows the IP and MAC of the module
   esp8266output();
   //fprintf(fp, "AT+CIPMUX=1\r"); esp8266output();
   //fprintf(fp, "AT+CIPSERVER=1,5000\r"); esp8266output();
   //fprintf(fp, "AT\r"); esp8266output();
   //fprintf(fp, "AT\r"); esp8266output();
   //fprintf(fp, "AT+CWMODE=2\r"); esp8266output();
   //fprintf(fp, "AT+CWSAP=\34ESPModul\34,\34testid\34,5,3\r"); esp8266output();
   //fprintf(fp, "AT+RST\r"); longdelay(2000000); esp8266output(); esp8266output();
   //
   //
   //
   //
   //
   wlanmode = (( IORD_ALTERA_AVALON_PIO_DATA(PIO_1_BASE) & 0xC0000));
   switch(wlanmode) {
    case 0x40000:
      printf("\n\r\n  WLAN dialog mode, please enter ESP8266 commands\n\r\n\r ");
      printf("\n\r>");
      //IOWR_ALTERA_AVALON_UART_STATUS(UART_1_BASE, 0); // clear all error flags
      while((( IORD_ALTERA_AVALON_PIO_DATA(PIO_1_BASE) & 0x40000)) && ( c != '\x1B'))
      {
        c=getc(stdin);
     	printf("%c",c);
     	fprintf(fp, "%c", c);
     	if(c == 13) {
     	  fprintf(fp, "\r\n");
     	  esp8266output();
     	  printf("\n\n>");
        }
      }
      printf("\n\n\r                                   ");
      printf("\n\r      WLAN loop Ende   \n\r");
      printloop();
      printf("\n\r         \n\r");
      break;
     //
     case 0x80000:
	   IoInit();
	   check_SD_Card();
	   readwlan();
	   printf("\n\n\n\r    Goto dialog   \n\r\n");
	   printf("\n\r>>");
	   while(1)
	      {
	           c=getc(stdin);
	          	printf("%c",c);
	          	fprintf(fp, "%c", c);
	          	if(c == 13) {
	          	  fprintf(fp, "\r\n");
	          	  esp8266output();
	          	  printf("\n\n>>");
	             }
	     }
	   break;
     //
     default:
    	printf("\n\n\n\r    Use default settings   \n\r\n");
     break;
   }
   //-----------------------------------------------------------------------------------------------------------------------
   //
   //
  printf("\n\r\n\n Ende");
  while(1){
  }
  return 0;
}
